from flask import render_template, flash, redirect, url_for, request
from app import app, db
from app.forms import *
import app.models as models

import yaml

@app.route("/")
@app.route("/index")
def index():
    return render_template("base.html")

@app.route("/PN", methods=["GET","POST"])
def PN():
    form = PNForm()
    form_validation = form.validate_on_submit()
    form = form_import(form)
    if form_validation:
        if form.exporter.data:
            flash("Ajout du référentiel PN: {} ".format(form.code.data))
            form_export(form)
        if form.sauvegarder.data:
            if not "pn" in locals():
                pn = models.PN()
            form.populate_obj(pn)
            db.session.add(pn)
            db.session.commit()
        return redirect(url_for("PN"))
    return render_template("PN.html", form = form)

@app.route("/AC", methods=["GET","POST"])
def AC():
    form = ACForm()
    form_validation = form.validate_on_submit()
    form = form_import(form)
    if form_validation:
        if form.exporter.data:
            flash("Ajout du référentiel AC: {} ".format(form.code.data))
            form_export(form)
            if not "ac" in locals():
                ac = models.AC()
            form.populate_obj(ac)
            db.session.add(ac)
            db.session.commit()
        return redirect(url_for("AC"))
    return render_template("AC.html", form = form)

@app.route("/SAE", methods=["GET","POST"])
def SAE():
    form = SAEForm()
    form_validation = form.validate_on_submit()
    form = form_import(form)
    if form_validation:
        if form.exporter.data:
            flash("Ajout du référentiel SAE: {} ".format(form.code.data))
            form_export(form)
            if not "sae" in locals():
                sae = models.SAE()
            form.populate_obj(sae)
            db.session.add(sae)
            db.session.commit()
        return redirect(url_for("SAE"))
    return render_template("SAE.html", form = form)

@app.route("/Ressource", methods=["GET","POST"])
def Ressource():
    form = RessourceForm()
    form_validation = form.validate_on_submit()
    form = form_import(form)
    if form_validation:
        if form.exporter.data:
            flash("Ajout du référentiel Ressource: {} ".format(form.code.data))
            form_export(form)
            if not "ressource" in locals():
                ressource = models.Ressource()
            form.populate_obj(ressource)
            db.session.add(ressource)
            db.session.commit()
        return redirect(url_for("Ressource"))
    return render_template("Ressource.html", form = form)

@app.route("/Competence", methods=["GET","POST"])
def Competence():
    form = CompetenceForm()
    form_validation = form.validate_on_submit()
    form = form_import(form)
    if form_validation:
        if form.exporter.data:
            flash("Ajout du référentielCompetence: {} ".format(form.code.data))
            form_export(form)
            if not "competence" in locals():
                competence = models.Competence()
            form.populate_obj(competence)
            db.session.add(competence)
            db.session.commit()
        return redirect(url_for("Competence"))
    return render_template("Competence.html", form = form)